#include "escapetilemap.h"
#include "escapetile.h"

#include <cassert>

EscapeTileMap::EscapeTileMap():
    TileMap()
{
}

EscapeTileMap::~EscapeTileMap()
{
}

void EscapeTileMap::addDefinition(char key,Texture& graphic)
 {
    assert(key != '\n');

    EscapeTile* temp = new EscapeTile(graphic);
    temp->isWall = isWall(key);
    temp->isStairs = isStairs(key);
    temp->isBad = isBad(key);
    temp->isWater = isWater(key);

    m_tileset.push_back(temp);
    m_charset.push_back(key);

    m_tiledefinitions[key] = temp;
 }

bool EscapeTileMap::isWall(int x, int y)
{
    TileSprite* temp = m_tilemap[y][x];
    EscapeTile* temp2 = (EscapeTile*)temp;
    return (temp2->isWall);
}

bool EscapeTileMap::isStairs(int x, int y)
{
    TileSprite* temp = m_tilemap[y][x];
    EscapeTile* temp2 = (EscapeTile*)temp;
    return (temp2->isStairs);
}

bool EscapeTileMap::isBad(int x, int y)
{
    TileSprite* temp = m_tilemap[y][x];
    EscapeTile* temp2 = (EscapeTile*)temp;
    return (temp2->isBad);
}

bool EscapeTileMap::isWater(int x, int y)
{
    TileSprite* temp = m_tilemap[y][x];
    EscapeTile* temp2 = (EscapeTile*)temp;
    return (temp2->isWater);
}

bool EscapeTileMap::isWall(char ch)
{
    if (ch == '0'|| ch == 'M' || ch == 'X' || ch == '@' || ch == 'T'|| ch == 'Y' || ch == 'I' || ch == 'm' || ch == 'U' || ch == '"' || ch == 'W')
    {
        return true;
    }
    else
    {
        return false;
    }
}

bool EscapeTileMap::isStairs(char ch)
{
    if (ch == '!' || ch == 'H' || ch == 'C')
    {
        return true;
    }
    else
    {
        return false;
    }
}

bool EscapeTileMap::isBad(char ch)
{
    if (ch == '^' || ch == 'b' || ch == 'd')
    {
        return true;
    }
    else
    {
        return false;
    }
}

bool EscapeTileMap::isWater(char ch)
{
    if (ch == '~' || ch == '-')
    {
        return true;
    }
    else
    {
        return false;
    }
}

