#ifndef GRAPHICS_H
#define GRAPHICS_H

#include <SDL/SDL.h>
#include <string>
using namespace std;

struct Vector2i
{
    Vector2i(int xx=0, int yy=0);
    int x;
    int y;
};

class Screen
{
public:
    Screen(int width, int height, string gamename);
    virtual ~Screen();
    int GetHeight(){ return m_height; }
    int GetWidth(){ return m_width; }
    SDL_Surface* GetSurface(){ return m_screen; }
    void flip(){ SDL_Flip(m_screen); }
private:
    SDL_Surface* init(int width, int height, string gamename);
    void close();

    SDL_Surface* m_screen;
    int    m_height;
    int    m_width;
    string m_gamename;
};

struct Texture
{
    Texture(string ffilename);
    virtual ~Texture();
    string filename;
    SDL_Surface* texture;
};

// Info for drawing a tile-based sprite
struct TileSprite
{
    TileSprite(Texture& ttexture, Vector2i ttilePos = Vector2i());
    Texture* texture;
    Vector2i tilePos;
    void Draw(Screen& screen);
};

#endif
