#include "player.h"
#include "graphics.h"

EscapePlayer::EscapePlayer(int x, int y):
    walk1_graphic("assets/player.png"),
    walk2_graphic("assets/player2.png"),
    hurt1_graphic("assets/playerhurt.png"),
    wet1_graphic ("assets/playerwet.png"),
    sprite(walk1_graphic),
    state(walk1)
{
    setPosition(x,y);
}

EscapePlayer::~EscapePlayer()
{
}

void EscapePlayer::move(direction dir)
{
    switch(dir)
    {
    case up:
        setPosition(sprite.tilePos.x,sprite.tilePos.y -1);
        break;
    case down:
        setPosition(sprite.tilePos.x,sprite.tilePos.y +1);
        break;
    case left:
        setPosition(sprite.tilePos.x -1,sprite.tilePos.y);
        break;
    case right:
        setPosition(sprite.tilePos.x +1,sprite.tilePos.y);
        break;
    default:
        break;
    }
    if (state == walk1)
    {
        setState(walk2);
    }
    else if (state == walk2)
    {
        setState(walk1);
    }
    else if (state == hurt)
    {
        setState(walk1);
    }
    else if (state == wet)
    {
        setState(walk1);
    }
}

void EscapePlayer::setPosition(int x, int y)
{
    sprite.tilePos.x = x;
    sprite.tilePos.y = y;
}

void EscapePlayer::setState(playerstate sstate)
{
    switch(state)
    {
    case walk1:
        if (sstate == walk2)
        {
            state = walk2;
            sprite.texture = &walk2_graphic;
        }
        else if (sstate == hurt)
        {
            state = hurt;
            sprite.texture = &hurt1_graphic;
        }
        else if (sstate == wet)
        {
            state = wet;
            sprite.texture = &wet1_graphic;
        }
        break;
    case walk2:
        if (sstate == walk1)
        {
            state = walk1;
            sprite.texture = &walk1_graphic;
        }
        else if (sstate == hurt)
        {
            state = hurt;
            sprite.texture = &hurt1_graphic;
        }
        else if (sstate == wet)
        {
            state = wet;
            sprite.texture = &wet1_graphic;
        }
        break;
    case hurt:
        if (sstate == walk1 || sstate == walk2)
        {
            state = walk1;
            sprite.texture = &walk1_graphic;
        }
        break;
    case wet:
        if (sstate == walk1 || sstate == walk2)
        {
            state = walk1;
            sprite.texture = &walk1_graphic;
        }
        break;
    default:
        break;
    }
}
