#include <map>
#include <vector>
#include <string>
#include <fstream>
#include <algorithm>
#include <cassert>

#include "tilemap.h"
using namespace std;

TileMap::TileMap()
{
}

TileMap::~TileMap()
{
    // Delete Tileset
    for(unsigned int i = 0; i < m_tileset.size(); i++)
    {
        delete m_tileset[i];
    }
}

void TileMap::clear()
{
    m_tilemap.clear();
}

void TileMap::addDefinition(char key,Texture& graphic)
{
    assert(key != '\n');

    TileSprite* temp = new TileSprite(graphic);

    m_tileset.push_back(temp);
    m_charset.push_back(key);

    m_tiledefinitions[key] = temp;
}

void TileMap::load(string filename)
{
    clear();
    ifstream file(filename.c_str());
    char temp;

    unsigned int currentRow = 0;
    unsigned int currentColumn = 0;

    while(!file.eof())
    {
        file.get(temp);

        bool isEndOfLineCharacter = (temp == '\n');
        // Checks to make sure that the letter is part of our charset
        vector<char>::iterator it = find(m_charset.begin(), m_charset.end(), temp);
        bool isPartOfCharset = (it != m_charset.end());

        if(isEndOfLineCharacter == true)
        {
            currentRow ++;
            currentColumn = 0;
        }
        else if(isPartOfCharset == true)
        {
            if(currentRow >= m_tilemap.size())
            {
                m_tilemap.resize(currentRow +1);
            }
            m_tilemap[currentRow].push_back(m_tiledefinitions[temp]);
            currentColumn ++;
        }
    }
}

void TileMap::draw(Screen& screen)
{
    for(unsigned int y = 0; y < m_tilemap.size(); y++)
    {
        for(unsigned int x = 0; x < m_tilemap[y].size(); x++)
        {
            m_tilemap[y][x]->tilePos = Vector2i(x,y);
            m_tilemap[y][x]->Draw(screen);
        }
    }
}
