#ifndef TILEMAP_H
#define TILEMAP_H

#include "graphics.h"

#include <map>
#include <vector>
#include <string>

#include <SDL/SDL.h>
using namespace std;

class TileMap
{
public:
    TileMap();
    virtual ~TileMap();
    virtual void addDefinition(char key,Texture& graphic);
    void load(string filename);
    void draw(Screen& screen);
protected:
    void clear();
    string m_filename;
    vector< vector<TileSprite*> > m_tilemap;
    map< char,TileSprite* > m_tiledefinitions;

    vector< TileSprite* > m_tileset;
    vector< char > m_charset;
};

#endif
